#include"Room.h"
#include"Stack.h"
#include<iostream>
#include<fstream>
#include<string>
using namespace std;

//Default empty constructor for a room
Room::Room()
{
}
//this function will read all the variable settings for a room and set them.
void Room::InitRoom(ifstream & infile)
{
	string s;
	getline(infile,description);
	getline(infile,lookdescription);
	infile>>look;
	infile>>canShoot;
	infile>>ComUse;
	infile>>medpac;
	infile>>gun;
	infile>>key;
	infile>>north;
	infile>>south;
	infile>>east;
	infile>>west;
	infile>>enemy;
	infile>>northlevel;
	infile>>southlevel;
	infile>>eastlevel;
	infile>>westlevel;
	getline(infile,s);
	getline(infile,ComDescription);
}
//This function displays the basic room description
void Room::Description()
{
	if(enemy==12)
		cout<<"As you step into the room you see before you a gigantic alien, the mother of the \naliens aboard the ship.  She is over 15 feet tall and has four long arms with \n\ndeadly claws at the end of them.  She bares her teeth at you and moves her \n\narms into an attack position.  She lets out a growl so loud that it rocks the \n\nentire ship.  SHE'S ATTACKING!!!\n"<<endl;
	else if(enemy==8)
		cout<<"As you move into the room you see... A LARGE ALIEN THAT IS ABOUT TO ATTACK \n\nYOU!!!\n"<<endl;
	else if(enemy==4)
		cout<<"There is a light in the middle of the room flickering on and off and on.  When \n\nthe light is on, you can make see that the room is fairly disheveled and off in \nthe corner you see something about half your size.  As it turns around toward \n\nyou it looks like some strange alien and it is finishing off what appears \n\nto have been a researcher.  Just then the alien starts charging for you... \n\nSHOOT IT!!!\n"<<endl;
	else
	{
		int start=0;
		int size=description.length();
		while(start<size)
		{
			for(int i=79;i>0;i--)
			{
				if(description[start+i]==' ')
				{
					cout<<description.substr(start,i)<<"\n"<<endl;
					start=start+i+1;
					break;
				}
			}
		}
	}
}
//This function displays a better description of the room and its contents
void Room::Look(int keylv)
{
	look=true;
	int start=0;
	int size=lookdescription.length();
	if(keylv==3&&gun)
		cout<<" The small closet opens and inside you see a concussion rifle and a medpac!!\n"<<endl;
	else
	{
	while(start<size)
	{
		for(int i=79;i>0;i--)
		{
			if(lookdescription[start+i]==' ')
			{
				cout<<lookdescription.substr(start,i)<<"\n"<<endl;
				start=start+i+1;
				break;
			}
		}
	}
	}
}
//this function takes an item in the room if there is one to take
void Room::Take(string item,Stack & s,int & keylv,int & damage)
{
	if(item=="key")
	{
		if(key)
		{
			keylv++;
			cout<<"You now have a level "<<keylv<<" key.\n"<<endl;
			key=false;
		}
		else
			cout<<"There is no key in this room."<<endl;
	}
	else if(item=="medpac")
	{
		if(medpac)
		{
			cout<<"You put the MedPac in your pack\n"<<endl;
			string str="medpac";
			s.push(str);
			medpac=false;
		}
		else
			cout<<"No Medpacs in this room."<<endl;
	}
	else if(item=="rifle")
	{
		if(gun&&keylv==3)
		{
			cout<<"With your new cuncussion rifle you now do twice the damage as before\n"<<endl;
			damage=4;
			gun=false;
		}
		else
			cout<<"There is no gun to take."<<endl;
	}
	else if(item=="book"||item=="magazine")
		cout<<"You pick it up and flip through it but it does not look that interesting.\n"<<endl;
	else if(item=="egg")
		cout<<"You walk over to the egg and try and lift it but it is much to heavy.  The only \nway you could lift it is if you were fueled by some super-human fury.\n"<<endl;
	else
		cout<<"You cannot take that.\n"<<endl;
}
//this function handles the user using medpacs and comstations
void Room::Use(string item, Stack & s,int & health)
{
	if(item=="comm")
	{
		if(ComUse)
		{
			int start=0;
			int size=ComDescription.length();
			while(start<size)
			{
				for(int i=79;i>0;i--)
				{
					if(ComDescription[start+i]==' ')
					{
						cout<<ComDescription.substr(start,i)<<"\n"<<endl;
						start=start+i+1;
						break;
					}
				}
			}
		}
		else
			cout<<"There is no CommStation in the room.\n"<<endl;
	}
	else if(item=="medpac")
	{
		if(!s.empty())
		{
			health=health+10;
			if(health>15)
				health=15;
			s.pop();
			cout<<"Health: "<<health<<endl;
		}
		else
			cout<<"You have no medpacs in your inventory."<<endl;
	}
	else
		cout<<"You cannot use that."<<endl;
}
//this function handles combat
void Room::Shoot(int damage,int & health)
{
	if(canShoot&&enemy>0)
	{
		enemy=enemy-damage;
		if(enemy>8)
			health=health-4;
		else if(enemy>4&&enemy<=8)
			health=health-3; 
		else if(enemy<=0)
			cout<<"";
		else
			health=health-2; 
		cout<<"Health: "<<health<<"\nEnemy: "<<enemy<<endl;
	}
	if(canShoot&&enemy<=0)
		cout<<"You have killed everything in the room."<<endl;
	if(!canShoot)
		cout<<"There is nothing to shoot here."<<endl;
}
//This function handles movement from room to room
void Room::Exit(string s,int keylv,int & posX,int & posY)
{
	if(s=="north"&&north)
	{
		if(keylv>=northlevel&&enemy>0)
			cout<<"The alien cuts you off from the exit...\n"<<endl;
		else if(keylv>=northlevel&&enemy<=0)
			posY--;
		else
			cout<<"You need a higher level key.\n"<<endl;
	}
	else if((s=="south")&&(south))
	{
		if(keylv>=southlevel&&enemy>0)
			cout<<"The alien cuts you off from the exit...\n"<<endl;
		else if(keylv>=southlevel&&enemy<=0)
			posY++;
		else
			cout<<"You need a higher level key.\n"<<endl;
	}
	else if(s=="east"&&east)
	{
		if(keylv>=eastlevel&&enemy>0)
			cout<<"The alien cuts you off from the exit...\n"<<endl;
		else if(keylv>=eastlevel&&enemy<=0)
			posX++;
		else
			cout<<"You need a higher level key.\n"<<endl;
	}
	else if(s=="west"&&west)
	{
		if(keylv>=westlevel&&enemy>0)
			cout<<"The alien cuts you off from the exit...\n"<<endl;
		else if(keylv>=westlevel&&enemy<=0)
			posX--;
		else
			cout<<"You need a higher level key.\n"<<endl;
	}
	else
		cout<<"There is no exit that way.\n"<<endl;
}
void Room::help()
{
	cout<<"Commands:\n\ntake medpac  look\n\ntake key     take rifle\n\nuse medpac   use comm\n\nshoot        move north\n\nmove south   move east\n\nmove west    help\n\ninventory    exit\n\n";
}